/*
 * @(#)RubikU.c
 *
 * Copyright 1994 - 2023  David A. Bagley, bagleyd AT verizon.net
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Undo algorithm for Rubik */

#include "RubikP.h"

RubikLoc  *startLoc[MAX_FACES] =
{
	NULL, NULL, NULL, NULL, NULL, NULL
};

static void
newStack(RubikStack *s)
{
	if (s->lastMove != NULL || s->firstMove != NULL)
		return;
	if (!(s->lastMove = (MoveStack *) malloc(sizeof (MoveStack)))) {
		DISPLAY_ERROR("Not enough memory, exiting.");
	}
	if (!(s->firstMove = (MoveStack *) malloc(sizeof (MoveStack)))) {
		DISPLAY_ERROR("Not enough memory, exiting.");
	}
	s->firstMove->previous = s->lastMove->next = NULL;
	s->firstMove->next = s->lastMove;
	s->lastMove->previous = s->firstMove;
	s->count = 0;
}

static void
pushStack(RubikStack *s, moveRecord **move)
{
	if (!(s->currMove = (MoveStack *) malloc(sizeof (MoveStack)))) {
		DISPLAY_ERROR("Not enough memory, exiting.");
	}
	s->lastMove->previous->next = s->currMove;
	s->currMove->previous = s->lastMove->previous;
	s->currMove->next = s->lastMove;
	s->lastMove->previous = s->currMove;
	*move = &(s->currMove->move);
	s->count++;
}

static void
popStack(RubikStack *s)
{
	s->currMove = s->lastMove->previous;
	s->lastMove->previous->previous->next = s->lastMove;
	s->lastMove->previous = s->lastMove->previous->previous;
	free(s->currMove);
	s->count--;
}

static moveRecord *
topStack(RubikStack *s)
{
	return &(s->lastMove->previous->move);
}

static int
emptyStack(RubikStack *s)
{
	return (s->lastMove->previous == s->firstMove);
}

static void
flushStack(RubikStack *s)
{
	while (s->lastMove->previous != s->firstMove) {
		s->currMove = s->lastMove->previous;
		s->lastMove->previous->previous->next = s->lastMove;
		s->lastMove->previous = s->lastMove->previous->previous;
		free(s->currMove);
	}
	s->count = 0;
}

static void
deleteStack(RubikStack *s)
{
	flushStack(s);
	if (s->firstMove) {
		free(s->firstMove);
		s->firstMove = NULL;
	}
	if (s->lastMove) {
		free(s->lastMove);
		s->lastMove = NULL;
	}
}

/**********************************/

void
newMoves(RubikStack *s)
{
	newStack(s);
}

void
deleteMoves(RubikStack *s)
{
	deleteStack(s);
}

static void
writeMove(moveRecord *move, int direction, int control,
		int face, int position)
{
#if 0
	move->direction = direction;
	move->control = control;
	move->face = face;
#endif
	move->packed = (unsigned short int) (((control & 0xF) << 8) +
		((direction & 0xF) << 4) + (face & 0xF));
	move->position = position;
}

static void
readMove(moveRecord *move, int *direction, int *control,
		int *face, int *position)
{
#if 0
	*direction = move->direction;
	*control = move->control;
	*face = move->face;
#endif
	*face = (int) (move->packed & 0xF);
	*direction = (int) ((move->packed >> 4) & 0xF);
	*control = (int) ((move->packed >> 8) & 0xF);
	*position = move->position;
}

void
setMove(RubikStack *s, int direction, int control,
		int face, int position)
{
	moveRecord *move;

	pushStack(s, &move);
	writeMove(move, direction, control, face, position);
}

void
getMove(RubikStack *s, int *direction, int *control,
		int *face, int *position)
{
	readMove(topStack(s), direction, control, face, position);
	popStack(s);
}

int
madeMoves(RubikStack *s)
{
	return !emptyStack(s);
}

void
flushMoves(RubikWidget w, RubikStack *s, Boolean undo)
{
	int face, position;

	flushStack(s);
	if (undo) {
		for (face = 0; face < MAX_FACES; face++)
			for (position = 0; position < sizeFace(w, face); position++) {
				startLoc[face][position].face =
					w->rubik.cubeLoc[face][position].face;
				startLoc[face][position].rotation =
					w->rubik.cubeLoc[face][position].rotation;
			}
	}
}

int
numMoves(RubikStack *s)
{
	return s->count;
}

Boolean
scanMoves(FILE *fp, RubikWidget w, int moves)
{
	int direction, control, face, position, k, c;

	for (k = 0; k < moves; k++) {
		while ((c = getc(fp)) != EOF && c != SYMBOL);
		if (fscanf(fp, "%d %d %d %d",
				&direction, &control, &face, &position) != 4) {
			(void) fprintf(stderr,
				"corrupt scan, expecting 4 integers for move %d\n", k);
			return False;
		}
		movePuzzle(w, face, position, direction, control, INSTANT);
	}
	return True;
}

void
printMoves(FILE *fp, RubikStack *s)
{
	int direction, control, face, position, counter = 0;

	s->currMove = s->firstMove->next;
	(void) fprintf(fp, "moves\tdir\tcontrol\tface\tposition\n");
	while (s->currMove != s->lastMove) {
		readMove(&(s->currMove->move),
			&direction, &control, &face, &position);
		(void) fprintf(fp, "%d%c\t%d\t%d\t%d\t%d\n",
			++counter, SYMBOL, direction, control, face, position);
		s->currMove = s->currMove->next;
	}
}

Boolean
scanStartPosition(FILE *fp, RubikWidget w)
{
	int face, position, num, c;

	while ((c = getc(fp)) != EOF && c != SYMBOL);
	for (face = 0; face < MAX_FACES; face++)
		for (position = 0; position < sizeFace(w, face); position++) {
			if (fscanf(fp, "%d ", &num) != 1) {
				(void) fprintf(stderr,
					"corrupt start record, expecting an integer for %d %d\n",
					face, position);
				return False;
			}
			startLoc[face][position].face = (char) num;
			if (w->rubik.orient) {
				if (fscanf(fp, "%d ", &num) != 1) {
					(void) fprintf(stderr,
						"corrupt start orient record, expecting an integer for %d %d\n",
						face, position);
					return False;
				}
				startLoc[face][position].rotation = (char) num;
			}
		}
	return True;
}

void
printStartPosition(FILE *fp, RubikWidget w)
{
	int face, position;

	(void) fprintf(fp, "\nstartingPosition%c\n", SYMBOL);
	for (face = 0; face < MAX_FACES; face++) {
		for (position = 0; position < sizeFace(w, face); position++) {				int width;
			(void) fprintf(fp, "%4d", startLoc[face][position].face);
			if (w->rubik.orient) {
				(void) fprintf(fp, "%3d",
					startLoc[face][position].rotation);
			}
			if (face == 1 || face == 3) {
				width = w->rubik.sizeZ;
			} else {
				width = w->rubik.sizeX;
			}
			if ((position + 1) % width == 0) {
				(void) fprintf(fp, "\n");
			}

		}
		(void) fprintf(fp, "\n");
	}
}

void
setStartPosition(RubikWidget w)
{
	int face, position;

	for (face = 0; face < MAX_FACES; face++)
		for (position = 0; position < sizeFace(w, face); position++) {
			w->rubik.cubeLoc[face][position].face =
				startLoc[face][position].face;
			if (w->rubik.orient)
				w->rubik.cubeLoc[face][position].rotation =
					startLoc[face][position].rotation;
		}
	drawAllPieces(w);
}
